"""
 ***************************************************************************
                             Custom widgets module
                             -------------------
    begin                : Sat Dec 14 2002
    copyright            : (C) 2002 by Ricardo Niederberger Cabral
    email                : nieder@mail.ru
    Time-stamp:            <2003-01-08 02:30:35 rnc>
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************
"""
from qt import *
try:
    from qttable import QTable,QComboTableItem,QTableItem
except:
    print "Unable to import some QT table modules. Metadata editing may not work"
from string import *
import os,random,traceback
try:
    from AlbumForm import *
    from MetaForm import *
    from HTMLAlbum import *
except:
    print "Unable to import some imgSeek modules. Some features will not work."
class DragListView(QListView):
    def __init__(self, *args):
        apply(QListView.__init__,(self, ) + args)
        self.setAcceptDrops(1)
        self.viewport().setAcceptDrops(1)
        self.dragids=[]
        self.drobj=None
        self.dropItem=None        
        self.mousePressed=0
    def contentsDragMoveEvent(self, e):
        vp = self.contentsToViewport( e.pos() )
        i = self.itemAt( vp )
        if  i and i.isGroup:
            e.accept()
            e.acceptAction()
            self.dropItem=i
            return
        if not i:
            e.accept()
            e.acceptAction()
            self.dropItem=-1
            return
        #is a file
        e.ignore()
        self.dropItem=None
    def contentsDragLeaveEvent(self, e):
        self.dropItem=None
    def contentsDropEvent(self, e):
        vp = self.contentsToViewport( e.pos() )
        i = self.itemAt( vp )
        if not i or i.isGroup:
            e.accept()
            it=self.firstChild()
            self.dragids=[]
            while it:
                if self.isSelected(it):
                    self.dragids.append(it)
                it=it.itemBelow()                    
            self.movedcb(self.dropItem,self.dragids)
    def contentsMouseMoveEvent(self, e):
        if self.mousePressed:
            dx=self.presspos.x()-e.pos().x()
            dy=self.presspos.y()-e.pos().y()
            self.mousePressed=0
            QDragObject(self.viewport()).dragMove()
    def contentsMouseReleaseEvent(self, e):
        self.mousePressed=0
            
    def contentsMousePressEvent(self,e):
        QListView.contentsMousePressEvent(self,e)
        if e.button() ==2: return
        p = self.contentsToViewport( e.pos() )
        i = self.itemAt( p )        
        if  i:
            self.clickedcb(i)
            self.presspos = e.pos()
            self.mousePressed = 1
        return
        it=self.firstChild()
        self.dragids=[]
        while it:
            if self.isSelected(it):
                self.dragids.append(it)
            it=it.itemBelow()                    

            
 
class AlbumWiz(htmlalbumform):
    def __init__(self, parent,htmllist,curdb):
        htmlalbumform.__init__(self,parent)
        self.dirlist=htmllist
        self.intlist={} #maps a string (which is on the listbox to a pair [type,id]
        self.curdb=curdb
        self.setFinishEnabled(self.page3,1)
        self.themecomboBox.insertItem("Acqua")
        for cap in self.curdb.metafields:
            self.availablecaptionlist.insertItem(cap)
        self.updateDirList()
    def showEvent(self,e):
        self.updateDirList()
    def updateDirList(self):
        self.htmlsourcelistbox.clear()
        for dir in self.dirlist:
            if dir[0]=="Group":
                str="Group: %s - %s" % (self.curdb.groups[dir[1]][0],self.curdb.groups[dir[1]][1])
            elif dir[0]=="SimCategory":
                str="Images similar to: %s - %s" % (self.curdb.img[self.curdb.simgroups[dir[1]][1]][0],self.curdb.simgroups[dir[1]][0])
            elif dir[0]=="Dir":
                str="Database dir: %s" % self.curdb.dirs[dir[1]][0]
            elif dir[0]=="SysDir":
                str="System dir: %s" % dir[1]
            elif dir[0]=="Volume":
                str="Volume: %s - %s" % (self.curdb.volumes[dir[1]][3],self.curdb.volumes[dir[1]][2])
            self.intlist[str]=dir[:]
            self.htmlsourcelistbox.insertItem(str)
    def accept(self):
        htmlalbumform.accept(self)
        ha=HTMLAlbum(self)
        str=ha.start()
        QMessageBox.information( self, "imgSeek",str)
    def reject(self):
        htmlalbumform.reject(self)
    def htmlalbumform_helpClicked(self):
        pass
    def removehtmlsourcebtn_clicked(self):
        torem=[]
        for i in range(self.htmlsourcelistbox.count()):
            if self.htmlsourcelistbox.isSelected(i): torem.append(i)
        while len(torem):
            wasrem=torem[0]
            self.htmlsourcelistbox.removeItem(torem[0])
            del torem[0]
            for i in range(len( torem)):
                if torem[i]>wasrem:torem[i]=torem[i]-1
    def addinfothumbbtn_clicked(self):
        for i in range(self.availablecaptionlist.count()):
            if self.availablecaptionlist.isSelected(i):
                self.includedcaptionlist.insertItem(self.availablecaptionlist.text(i))
                self.availablecaptionlist.removeItem(i)
                self.addinfothumbbtn_clicked()
    def delinfothumbbtn_clicked(self):
        for i in range(self.includedcaptionlist.count()):            
            if self.includedcaptionlist.isSelected(i):
                self.availablecaptionlist.insertItem(self.includedcaptionlist.text(i))
                self.includedcaptionlist.removeItem(i)
                self.delinfothumbbtn_clicked()
    def inplaceradio_toggled(self,a0):
        self.destoptionsgroup.setEnabled(0)
    def symlinkradio_toggled(self,a0):
        self.destoptionsgroup.setEnabled(1)
                
## class CategMgrForm(CategoryMgtForm):
##     def __init__(self, parent,curdb):
##         self.curdb=curdb
##         CategoryMgtForm.__init__(self, parent)
##         self.curgroup=-1
##         self.curname=""
##         self.updateCombo()
##     def catnamecombo_activated(self,a0):        
##         self.descEdit.setText(self.curdb.groups[self.curdb.groups.keys()[a0]][1])
##         self.curgroup=self.curdb.groups.keys()[a0]
##     def delcategbtn_clicked(self):
##         res=QMessageBox.information( self, "imgSeek","Are you sure you want to remove from database this group and all subgroups recursively ?",   QString("&Remove group"), QString("Cancel"))
##         if res: return
##         self.curdb.removeGroup(self.curgroup)
##     def newcategbtn_clicked(self):
##         text = str(QInputDialog.getText("imgSeek","New group name:" ,QLineEdit.Normal, "")[0])
##         if text:
##             self.curname=text
##             self.catnamecombo.setText(text)            
##     def applyfieldbtn_clicked(self):
##         if self.curgroup == -1 : return
##         self.curdb.groups[self.curgroup][0]=self.curname
##         self.curdb.groups[self.curgroup][1]=str(self.descEdit.text())        
##     def updateCombo(self):
##         self.catnamecombo.clear()
##         for gid in self.curdb.groups.keys():
##             self.catnamecombo.insertItem(self.curdb.groups[gid][0])      
class MetaWnd(metaform):
    def __init__(self, parent,curdb,ifile=None):
        self.curdb=curdb
        metaform.__init__(self, parent)
        self.imgIdx=0
        self.curfid=None
        #popup 
        self.fieldMenu=QPopupMenu(self) 
        self.fieldMenu.insertItem ( parent.fileNewAction.iconSet(),"&New parameter", self.onNewField)
        self.fieldMenu.insertItem ( parent.resethtml.iconSet(), "&Remove parameter", self.onDelField)
        # other inits
        self.metalist=None
        self.combos=[]
        self.selectedRow=None
        self.updateCombos()
        self.readonlyfields=["Filesize","Filename","Format","Dimensions"]
        if ifile: # requested file to be shown immediately
            self.showFile(ifile)            
        else: #simple show first file on dbase
            self.showFile(self.curdb.meta.keys()[0])
    def onNewField(self):
        text = str(QInputDialog.getText("imgSeek","New field name:" ,QLineEdit.Normal, "")[0])
        if not text: return
        if text in self.curdb.meta[self.curfid].keys():
            QMessageBox.information( self, "imgSeek","There is already a field with this name, please try another.")
            return
        self.tableMeta.setNumRows(self.tableMeta.numRows()+1)
        if text not in self.curdb.metafields:
            self.curdb.metafields.append(text)
            self.updateCombos()
        a=QComboTableItem ( self.tableMeta, self.metalist, 1 )
        a.setCurrentItem(text)
        self.combos.append(a)
        self.tableMeta.setItem(self.tableMeta.numRows()-1,0,a)        
    def onDelField(self):        
        self.tableMeta.removeRow(self.selectedRow)
        self.saveMeta()
    def tableMeta_currentChanged(self,a0,a1):
        self.saveMeta()
    def updateCombos(self):
        if not len(self.curdb.metafields): return        
        lst=QStringList()
        for mtf in self.curdb.metafields:
            lst.append(mtf)
        for cmb in self.combos:
            cmb.setStringList(lst)
        self.metalist=lst
    def showFile(self,fid):
        self.imgIdx=self.curdb.img.keys().index(fid)
        self.curfid=fid
        self.tableMeta.setNumRows(len(self.curdb.meta[fid].keys()))
        cnt=0
        for cmb in self.combos: del cmb
        self.combos=[]
        kes=self.curdb.meta[fid].keys()[:]
        kes.sort()
        for field in kes:
            if field not in self.curdb.metafields:
                self.curdb.metafields.append(field)
                self.updateCombos()        
        for field in kes:
            a=QComboTableItem ( self.tableMeta, self.metalist, 1 )
            self.combos.append(a)
            self.tableMeta.setItem(cnt,0,a)
            self.tableMeta.setText(cnt,1,str(self.curdb.meta[fid][field]))
            a.setCurrentItem(field)
            try:
                if field in self.readonlyfields:
                    self.tableMeta.setItem(cnt,1,QTableItem ( self.tableMeta,QTableItem.Never, str(self.curdb.meta[fid][field])))
            except:
                print "PYQT 3.4 error, please install PyQT 3.5"
                pass
            cnt=cnt+1
        self.thumbLabel.setPixmap(QPixmap(self.curdb.getThumb(self.curdb.img[fid][0])))
        self.indexLabel.setText(str(self.imgIdx+1)+" / "+str(len(self.curdb.img.keys())))
    def saveMeta(self):
        """save metadata for currently shown image. Called by prev/next/apply"""
        self.curdb.meta[self.curfid]={}
        savedfields=[]
        for ri in range(self.tableMeta.numRows()):
            try:
                if str(self.tableMeta.text(ri,0)) in savedfields:                    
                    continue
                savedfields.append(str(self.tableMeta.text(ri,0)))
                self.curdb.meta[self.curfid][str(self.tableMeta.text(ri,0))]=str(self.tableMeta.text(ri,1))
            except:
                print "Error saving metadata field:"+str(ri)
        self.curdb.dirty=1
    def previousBtn_clicked(self):
        self.saveMeta()        
        self.imgIdx=self.imgIdx-1
        if self.imgIdx<0:self.imgIdx=len(self.curdb.meta.keys()) -1
        self.showFile(self.curdb.meta.keys()[self.imgIdx])
    def nextButton_clicked(self):
        self.saveMeta()
        self.imgIdx=self.imgIdx+1
        if self.imgIdx>=len(self.curdb.meta.keys()):
            self.imgIdx=0
        self.showFile(self.curdb.meta.keys()[self.imgIdx])
    def ApplyBtn_clicked(self):
        self.saveMeta()
    def tableMeta_contextMenuRequested(self,a0,a1,a2):
        self.selectedRow=a0
        self.fieldMenu.popup(a2)
        
class ColorClickableLabel(QLabel):
    def __init__(self, *args):
        apply(QLabel.__init__,(self, ) + args)
        self.color=[0,0,0]
        self.callBack=None
    def mousePressEvent (self,e ):
        rgb=self.pixmap().convertToImage().pixel(e.x(),e.y())
        self.color=[qRed(rgb),qGreen(rgb),qBlue(rgb)]
        if self.callBack: self.callBack()
class Painting(QWidget):
    def __init__(self, *args):
        apply(QWidget.__init__,(self, ) + args)
        self.buffer = QPixmap(128,128)
        self.buffer.fill()
        self.pen=QPen()
        self.pen.setColor(QColor(0,0,0,QColor.Rgb))
        self.dlg=None
    def paintEvent(self, ev):
        bitBlt(self, 0, 0, self.buffer)
    def heightForWidth ( self, w ):
         return int(w)
    def resizeEvent (self,e):
        self.resize(QSize(e.size().width(),self.heightForWidth(e.size().width())))
        QWidget.resizeEvent(self,e)        
    def mouseMoveEvent(self, ev):
        self.p = QPainter()
        self.p.begin(self.buffer)         
        self.pen.setColor(QColor(self.dlg.DrawQueryColorPixmap.color[0],self.dlg.DrawQueryColorPixmap.color[1],self.dlg.DrawQueryColorPixmap.color[2],QColor.Rgb))
        self.p.setPen( self.pen )
        w=self.pen.width()
        self.p.drawEllipse(ev.pos().x()-w/2,ev.pos().y()-w/2,w,w)
        self.p.flush()
        self.p.end()
        bitBlt(self, 0, 0, self.buffer)
    def mousePressEvent(self, ev):
        self.p = QPainter()
        self.p.begin(self.buffer)
        self.p.drawPoint(ev.pos())
        self.currentPos=QPoint(ev.pos())
        self.p.flush()
        self.p.end()
        bitBlt(self, 0, 0, self.buffer)
    def reset(self):
        self.buffer.fill()
        self.paintEvent(None)
    def resizeEvent(self, ev):
        tmp = QPixmap(self.buffer.size())
        bitBlt(tmp, 0, 0, self.buffer)
        self.buffer.resize(ev.size())
        self.buffer.fill()
        bitBlt(self.buffer, 0, 0, tmp)
class DummyItem:
    def __init__(self):
        pass
class MouseMoveLabel(QLabel):
    def __init__(self, *args):
        apply(QLabel.__init__,(self, ) + args)
        self.mousePressed=0
        self.mvCallback=None
        self.setCursor(QCursor(Qt.PointingHandCursor))
        self.setPaletteBackgroundColor(Qt.black)
        self.initPos=[0,0]
        self.setText("\n\n\t\timgSeek 0.4\t\t\n\t\thttp://imgseek.sourceforge.net/\t\t\n\n")
        self.setPaletteForegroundColor(Qt.white)
        self.wnd=None
        self.imgmenu=QPopupMenu(self) #the popup for images
        self.imgmenu.insertItem ( "&Fit to window", self.onFit)        
        self.imgmenu.insertItem ( "&Natural size", self.onNatural)
        self.imgmenu.insertItem ( "&Zoom [+]", self.onZoomMore)        
        self.imgmenu.insertItem ( "&Zoom [-]", self.onZoomLess)
        self.imgmenu.insertItem ( "&Rotate", self.onRotate)        
        self.imgmenu.insertSeparator()
        self.imgmenu.insertItem ( "&Auto fit", self.onAutoFit,0,5)
        self.imgmenu.insertSeparator()
        self.imgmenu.insertItem ( "&Query for similar images", self.onQuery)
# insertItem ( const QString & text, const QObject * receiver, const char * member, const QKeySequence & accel = 0, int id = -1, int index = -1 )        
        self.imgmenu.setCheckable(1)
        self.origPixmap=None            # natural size pixmap
        self.infolabel=None             # label to set when zoomed
        self.fname=None                 # filename being displayed
        self.sview=None                 # my parent scrollview
        self.fitcb=None                 # if nonempty, tell slideview that should showimg with autofit
        self.querycb=None               # [callback function,selectedresult] to call when you want to search for an image
    def onQuery(self):
        a0=DummyItem()
        a0.filename=self.fname
        self.querycb[1].append(a0)
        self.querycb[0]()
    def onAutoFit(self):
        if self.imgmenu.isItemChecked(5):
            self.imgmenu.setItemChecked(5,0)
            self.fitcb.remove(1)
        else:
            self.imgmenu.setItemChecked(5,1)
            self.fitcb.append(1)
    def onRotate(self):
        try:
            fac=QInputDialog.getInteger("imgSeek","Rotation factor (in degrees):" ,90)
            if not fac[1]: return
            fac=fac[0]
            m=QWMatrix()
            #m.translate(10, -20)
            m.rotate(fac)
            aIm=self.pixmap().convertToImage().xForm(m)
            self.setPixmap(QPixmap(aIm))
        except:
            traceback.print_exc()
            QMessageBox.information( self, "imgSeek","Error rotating image or invalid factor provided.")                
    def onFit(self):
        #aIm=self.origPixmap.convertToImage().smoothScale ( self.sview.visibleWidth(), self.sview.visibleHeight(), QImage.ScaleMin)
        aIm=self.origPixmap.convertToImage().scale ( self.sview.visibleWidth(), self.sview.visibleHeight(), QImage.ScaleMin)
        self.setPixmap(QPixmap(aIm))
    def onZoomMore(self):
        aIm=self.origPixmap.convertToImage().scale ( int(self.pixmap().width()*1.4), self.pixmap().height(), QImage.ScaleMax)
        self.setPixmap(QPixmap(aIm))
    def onZoomLess(self):
        aIm=self.origPixmap.convertToImage().scale ( int(self.pixmap().width()/1.4), self.height(), QImage.ScaleMin)
        self.setPixmap(QPixmap(aIm))
    def onNatural(self):
        self.setPixmap(self.origPixmap)
    def mousePressEvent(self,e):
        if e.button()==2: #right click
            if not self.origPixmap:return
            self.imgmenu.popup(e.globalPos())
            return
        self.setCursor(QCursor(Qt.SizeAllCursor))        
        self.mousePressed=1
        self.initPos=[e.x(),e.y()]
    def mouseReleaseEvent(self,e):
        self.setCursor(QCursor(Qt.PointingHandCursor))        
        self.mousePressed=0
        delta=[e.x()-self.initPos[0],e.y()-self.initPos[1]]
        if self.mvCallback: self.mvCallback(delta)

class SlideShowDialog(QDialog):
    def __init__(self, *args):
        apply(QDialog.__init__,(self, ) + args)
        self.sv=  QScrollView(self)
        self.pixlabel = MouseMoveLabel(self.sv)
        self.pixlabel.mvCallback=self.onMouseDelta
        self.pixlabel.setScaledContents(0)
        self.slideIdx=0
        self.doRandom=0
        self.apix=QPixmap()
        self.flist=[]
        self.mtimer=None
        self.sv.addChild(self.pixlabel)
        self.vbox = QVBoxLayout(self)
        self.vbox.addWidget(self.sv)
        self.vbox.activate()
        self.move(0,0)
        self.showFullScreen()
        #self.resize(QSize(800,600))
        #### Popupmenus:
##         self.imgMenu=QPopupMenu(self) #the popup for images
##         self.imgMenu.insertItem ( "&Show full size", self.onResultsMenuShow)
##         self.imgMenu.insertItem ( "&Query for similar images", self.onResultsMenuQuery)
##         self.imgMenu.insertItem ( "&Move to another directory", self.onMoveImageMenu)
        #### show dlg
        self.show()
    def keyPressEvent (self,e):                
        if e.key()==Qt.Key_Space:
            self.jumpSlide()
        if e.key()==Qt.Key_Backspace:
            self.jumpSlide(-1)
        if e.key()==Qt.Key_R:
            self.doRandom=not self.doRandom
        QDialog.keyPressEvent(self,e)
    def showImg(self,fname,resz=1):
        """if resz=1, then the dlg will autoresize to images size
        """
        try:
            self.apix.load(fname)
        except:
            traceback.print_exc()
            QMessageBox.information( self, "imgSeek","Error loading selected image. Unable to display it")    
            return
        self.setCaption(fname)
        self.pixlabel.setPixmap(self.apix)        
    def onMouseDelta(self,delta):
        self.sv.scrollBy(-delta[0],-delta[1])
    def start(self,interv=3500):
        if not len(self.flist): return
        self.mtimer = QTimer(self)
        self.connect( self.mtimer, SIGNAL("timeout()"), self.onmTimer )
        self.mtimer.start(interv)
        self.onmTimer()
    def jumpSlide(self,step=1):
        if not len(self.flist): return
        if self.doRandom:
            idx=random.randrange(0,len(self.flist)-1)
        else:
            self.slideIdx=self.slideIdx+step
            if self.slideIdx>=len(self.flist): self.slideIdx=0
            if self.slideIdx<0 : self.slideIdx=len(self.flist)-1
            idx=self.slideIdx
        self.showImg(self.flist[idx],1)
    def onmTimer(self):
        self.jumpSlide()
    def closeEvent(self,e):
        if self.mtimer: self.mtimer.stop()        
        QDialog.closeEvent(self,e)

class ImgViewScroll(QScrollView):
    def __init__(self, *args):
        apply(QScrollView.__init__,(self, ) + args)

        self.pixlabel = MouseMoveLabel(self)
        self.pixlabel.sview=self
        self.pixlabel.mvCallback=self.onMouseDelta
        self.pixlabel.setScaledContents(0)
        self.fitcb=[]
        self.pixlabel.fitcb=self.fitcb

        self.apix=QPixmap()
        self.infolabel=None
        self.MainTabWidget=None
        self.addChild(self.pixlabel)
        
##     def keyPressEvent (self,e):
##         QDialog.keyPressEvent(self,e)
    def showImg(self,fname,fit=0):
        """if resz=1, then the dlg will autoresize to images size
        """
        try:
            self.apix.load(fname)
        except:
            traceback.print_exc()
            self.info("Error loading selected image. Unable to display it")
            return
        self.infolabel.setText(fname)        
        self.pixlabel.infolabel=self.infolabel        
        if self.fitcb:
            fit=1
        if fit:
            aIm=self.apix.convertToImage().scale ( self.visibleWidth(), self.visibleHeight(), QImage.ScaleMin)
            self.pixlabel.setPixmap(QPixmap(aIm))            
        else:
            self.pixlabel.setPixmap(self.apix)
        self.pixlabel.origPixmap=self.apix
        self.pixlabel.fname=fname
        #self.MainTabWidget.setCurrentPage(0)        
    def onMouseDelta(self,delta):
        self.scrollBy(-delta[0],-delta[1])

folder_closed_xpm=[
    "16 16 9 1",
    "g c #808080",
    "b c #c0c000",
    "e c #c0c0c0",
    "# c #000000",
    "c c #ffff00",
    ". c None",
    "a c #585858",
    "f c #a0a0a4",
    "d c #ffffff",
    "..###...........",
    ".#abc##.........",
    ".#daabc#####....",
    ".#ddeaabbccc#...",
    ".#dedeeabbbba...",
    ".#edeeeeaaaab#..",
    ".#deeeeeeefe#ba.",
    ".#eeeeeeefef#ba.",
    ".#eeeeeefeff#ba.",
    ".#eeeeefefff#ba.",
    ".##geefeffff#ba.",
    "...##gefffff#ba.",
    ".....##fffff#ba.",
    ".......##fff#b##",
    ".........##f#b##",
    "...........####."]

folder_open_xpm=[
    "16 16 11 1",
    "# c #000000",
    "g c #c0c0c0",
    "e c #303030",
    "a c #ffa858",
    "b c #808080",
    "d c #a0a0a4",
    "f c #585858",
    "c c #ffdca8",
    "h c #dcdcdc",
    "i c #ffffff",
    ". c None",
    "....###.........",
    "....#ab##.......",
    "....#acab####...",
    "###.#acccccca#..",
    "#ddefaaaccccca#.",
    "#bdddbaaaacccab#",
    ".eddddbbaaaacab#",
    ".#bddggdbbaaaab#",
    "..edgdggggbbaab#",
    "..#bgggghghdaab#",
    "...ebhggghicfab#",
    "....#edhhiiidab#",
    "......#egiiicfb#",
    "........#egiibb#",
    "..........#egib#",
    "............#ee#"]

folder_locked=[
    "16 16 10 1",
    "h c #808080",
    "b c #ffa858",
    "f c #c0c0c0",
    "e c #c05800",
    "# c #000000",
    "c c #ffdca8",
    ". c None",
    "a c #585858",
    "g c #a0a0a4",
    "d c #ffffff",
    "..#a#...........",
    ".#abc####.......",
    ".#daa#eee#......",
    ".#ddf#e##b#.....",
    ".#dfd#e#bcb##...",
    ".#fdccc#daaab#..",
    ".#dfbbbccgfg#ba.",
    ".#ffb#ebbfgg#ba.",
    ".#ffbbe#bggg#ba.",
    ".#fffbbebggg#ba.",
    ".##hf#ebbggg#ba.",
    "...###e#gggg#ba.",
    ".....#e#gggg#ba.",
    "......###ggg#b##",
    ".........##g#b##",
    "...........####."]

pix_file=[
    "16 16 7 1",
    "# c #000000",
    "b c #ffffff",
    "e c #000000",
    "d c #404000",
    "c c #c0c000",
    "a c #ffffc0",
    ". c None",
    "................",
    ".........#......",
    "......#.#a##....",
    ".....#b#bbba##..",
    "....#b#bbbabbb#.",
    "...#b#bba##bb#..",
    "..#b#abb#bb##...",
    ".#a#aab#bbbab##.",
    "#a#aaa#bcbbbbbb#",
    "#ccdc#bcbbcbbb#.",
    ".##c#bcbbcabb#..",
    "...#acbacbbbe...",
    "..#aaaacaba#....",
    "...##aaaaa#.....",
    ".....##aa#......",
    ".......##......."]

folderLocked =None
folderClosed =None
folderOpen =None
fileNormal =None


class FileItem(QListViewItem):
    def __init__(self,parent,s1,fulln):
        QListViewItem.__init__(self,parent,s1)
        self.fullName=fulln
    def setPixmap(self,px ):
        QListViewItem.setPixmap(self,0,px)

class Directory(QListViewItem):
    def __init__(self,parent,filename,fullname,sdo=0):
        QListViewItem.__init__(self,parent,filename)
        self.fullName=fullname
        self.f=filename
        self.p=None
        self.readable=QDir(fullname).isReadable()
        self.showDirsOnly=sdo
        if not self.readable:
            self.setPixmap(folderLocked )
        else:
            self.setPixmap(folderClosed )            
    def setPixmap(self,px ):
         QListViewItem.setPixmap(self,0,px)
    def setOpen(self, o ):
        if ( o ):
            self.setPixmap( folderOpen )
        else:
            self.setPixmap( folderClosed )
        if o and not self.childCount():            
            s=self.fullName
            thisDir=QDir( s )
            if not thisDir.isReadable():
                self.readable = 0
                self.setExpandable( 0)
                return
            for file in os.listdir(s):
                file=s+"/"+file
                fname=rfind(file,"/")
                if fname==-1:
                    smfile=file
                else:
                    smfile=file[fname+1:]                    
                # using "options" here is ok because imgSeek set this global module var on init
                if smfile[0]=="." and not int(options["browse.showdotfiles"]): continue
                if os.path.islink(file) and   not self.showDirsOnly:
                    item =  FileItem( self, smfile,file)
                elif os.path.isdir(file):
                    Directory(self, smfile,file)
                elif not self.showDirsOnly:
                    item=  FileItem( self, smfile,file)
                    item.setPixmap( fileNormal )                    
        QListViewItem.setOpen(self, o )
    def setup(self):
        self.setExpandable( 1)
        QListViewItem.setup(self)
class DirectoryView(QListView):
    def __init__(self,parent=None,name="",sdo=0):
        QListView.__init__(self,parent,name)
        self.dirsOnly=sdo
        self.setAcceptDrops( 0 )
        self.connect( self, SIGNAL( "doubleClicked(QListViewItem*)"),self.slotFolderSelected)
        self.connect( self, SIGNAL( "returnPressed(QListViewItem*)"),self.slotFolderSelected)
        self.connect( self, SIGNAL( "mouseButtonClicked(int,QListViewItem*,const QPoint&,int)"),self.clicked)
        self.browseDirMenu=QPopupMenu(self) #the popup for directories
        self.browseDirMenu.insertItem ( "&Add to database", self.onMenuAddDB)
        self.browseDirMenu.insertItem ( "Include on &HTML album", self.onMenuAddHTML)
        self.selectedItmFname=None
        self.htmllist=None
        self.cb=None                    # callback called when the user leftclicks on a file/dir
        self.addDircb=None              # callback called when the user asks for a dir to be added do dbase
        self.showDots=0
    def onMenuAddDB(self):
        if self.addDircb:
            self.addDircb(self.selectedItmFname)
    def onMenuAddHTML(self):
        self.htmllist.append(["SysDir",self.selectedItmFname])
    def clicked(self,but,a,p,c):
        if (not a): return
        if self.cb:
            if but==1:
                self.cb(a.fullName)
            if but==2:
                self.selectedItmFname=a.fullName
                self.browseDirMenu.popup(p)
    def slotFolderSelected(self,i ):
        if (not i): return
